#include <time.h>

#include <vector>
#include <map>

using std::vector;
using std::map;

#include "connection.hh"
#include "protocols.hh"
#include "stdin.hh"

class ConnectionCache
{
    struct ConnRec
    {
        Connection   Conn;
        time_t       LastTouch;
        
        ConnRec() : LastTouch(0) { }
    };
    vector<struct ConnRec> recs;
    map<Connection, unsigned> key2rec;
    
    bool IsExpiring(unsigned ConnID) const;
    
    struct StdinType *owner;
    
public:
    ConnectionCache(struct StdinType *o);
    ~ConnectionCache();
    
    /* Deletes a connection and sends a message. */
    void DeleteConnectionID(unsigned ConnID);
    
    /* Finds a connection entry or creates one and sends a message. */
    unsigned GetConnectionID(const Connection &conn);
    
    /* Finds a connection.
     * Note: If ConnID is out of range (use Has()!), this causes a crash.
     */
    const Connection &GetConnection(unsigned ConnID) const;

    bool Has(unsigned ConnID) const;
    
    void TouchConnection(unsigned ConnID);
    
    void Assign(unsigned ConnID, const Connection &conn);
};
